diff --git a/oflog/include/dcmtk/oflog/spi/factory.h b/oflog/include/dcmtk/oflog/spi/factory.h
index 1a78bb1..e0d0fd9 100644
--- a/oflog/include/dcmtk/oflog/spi/factory.h
+++ b/oflog/include/dcmtk/oflog/spi/factory.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    factory.h
 // Created: 2/2002
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2002-2009 Tad E. Smith
+// Copyright 2002-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,16 +25,19 @@
 #define DCMTK_LOG4CPLUS_SPI_FACTORY_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
 #include "dcmtk/oflog/layout.h"
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/helpers/property.h"
-#include "dcmtk/oflog/helpers/threads.h"
 #include "dcmtk/oflog/spi/filter.h"
 #include "dcmtk/oflog/spi/objreg.h"
-//#include <map>
-//#include <memory>
-//#include <vector>
+#include <memory>
+#include "dcmtk/ofstd/ofvector.h"
+#include <locale>
 
 
 namespace dcmtk {
@@ -50,7 +54,7 @@ namespace log4cplus {
             /**
              * Returns the typename of the objects this factory creates.
              */
-            virtual tstring getTypeName() = 0;
+            virtual log4cplus::tstring const & getTypeName() const = 0;
         };
 
 
@@ -69,7 +73,7 @@ namespace log4cplus {
             /**
              * Create an "Appender" object.
              */
-            virtual SharedAppenderPtr createObject(const helpers::Properties& props, tstring& error) = 0;
+            virtual SharedAppenderPtr createObject(const log4cplus::helpers::Properties& props) = 0;
         };
 
 
@@ -89,7 +93,7 @@ namespace log4cplus {
             /**
              * Create a "Layout" object.
              */
-            virtual OFauto_ptr<Layout> createObject(const helpers::Properties& props, tstring& error) = 0;
+            virtual OFauto_ptr<Layout> createObject(const log4cplus::helpers::Properties& props) = 0;
         };
 
 
@@ -109,22 +113,41 @@ namespace log4cplus {
             /**
              * Create a "Filter" object.
              */
-            virtual FilterPtr createObject(const helpers::Properties& props, tstring& error) = 0;
+            virtual FilterPtr createObject(const log4cplus::helpers::Properties& props) = 0;
         };
 
 
+        /**
+         * This abstract class defines the "Factory" interface to
+         * create STD_NAMESPACE locale instances.
+         */
+        class DCMTK_LOG4CPLUS_EXPORT LocaleFactory
+            : public BaseFactory
+        {
+        public:
+            typedef STD_NAMESPACE locale ProductType;
+            typedef STD_NAMESPACE locale ProductPtr;
+
+            LocaleFactory();
+            virtual ~LocaleFactory() = 0;
+
+            //! \returns STD_NAMESPACE locale instance
+            virtual ProductPtr createObject (
+                const log4cplus::helpers::Properties & props) = 0;
+        };
+
 
         /**
          * This template class is used as a "Factory Registry".  Objects are
-         * "entered" into the registry with a "name" using the
-         * <code>put()</code> method.  (The registry then owns the object.)
-         * These object can then be retrieved using the <code>get()</code>
+         * "entered" into the registry with a "name" using the 
+         * <code>put()</code> method.  (The registry then owns the object.)  
+         * These object can then be retrieved using the <code>get()</code> 
          * method.
-         *
+         * 
          * <b>Note:</b>  This class is Thread-safe.
          */
         template<class T>
-        class DCMTK_LOG4CPLUS_EXPORT FactoryRegistry : private ObjectRegistryBase {
+        class DCMTK_LOG4CPLUS_EXPORT FactoryRegistry : ObjectRegistryBase {
         public:
             typedef T product_type;
 
@@ -140,14 +163,14 @@ namespace log4cplus {
             bool put(OFauto_ptr<T> object) {
                  bool putValResult = putVal(object->getTypeName(), object.get());
                  object.release();
-                 return putValResult;
+                 return putValResult; 
             }
 
             /**
              * Used to retrieve an object from the registry.  (The registry
              * owns the returned pointer.)
              */
-            T* get(const tstring& name) const {
+            T* get(const log4cplus::tstring& name) const {
                 return OFstatic_cast(T*, getVal(name));
             }
 
@@ -161,6 +184,7 @@ namespace log4cplus {
         typedef FactoryRegistry<AppenderFactory> AppenderFactoryRegistry;
         typedef FactoryRegistry<LayoutFactory> LayoutFactoryRegistry;
         typedef FactoryRegistry<FilterFactory> FilterFactoryRegistry;
+        typedef FactoryRegistry<LocaleFactory> LocaleFactoryRegistry;
 
 
         /**
@@ -178,10 +202,74 @@ namespace log4cplus {
          */
         DCMTK_LOG4CPLUS_EXPORT FilterFactoryRegistry& getFilterFactoryRegistry();
 
-    }
+        /**
+         * Returns the "singleton" <code>LocaleFactoryRegistry</code>.
+         */
+        DCMTK_LOG4CPLUS_EXPORT LocaleFactoryRegistry& getLocaleFactoryRegistry();
+
+
+        template <typename ProductFactoryBase>
+        class LocalFactoryBase
+            : public ProductFactoryBase
+        {
+        public:
+            LocalFactoryBase (tchar const * n)
+                : name (n)
+            { }
+
+            virtual log4cplus::tstring const & getTypeName() const
+            {
+                return name;
+            }
+
+        private:
+            log4cplus::tstring name;
+        };
+
+
+        template <typename LocalProduct, typename ProductFactoryBase>
+        class FactoryTempl
+            : public LocalFactoryBase<ProductFactoryBase>
+        {
+        public:
+            typedef typename ProductFactoryBase::ProductPtr ProductPtr;
+
+            FactoryTempl (tchar const * n)
+                : LocalFactoryBase<ProductFactoryBase> (n)
+            { }
+
+            virtual ProductPtr createObject (helpers::Properties const & props)
+            {
+                return ProductPtr (new LocalProduct (props));
+            }
+        };
+
+
+        #define DCMTK_LOG4CPLUS_REG_PRODUCT(reg, productprefix, productname, productns, productfact) \
+        reg.put (																               \
+            OFauto_ptr<productfact> (                                                       \
+                    new log4cplus::spi::FactoryTempl<productns productname, productfact> (     \
+                    DCMTK_LOG4CPLUS_TEXT(productprefix)                                              \
+                    DCMTK_LOG4CPLUS_TEXT(#productname))))
+
+        #define DCMTK_LOG4CPLUS_REG_APPENDER(reg, appendername)                             \
+        DCMTK_LOG4CPLUS_REG_PRODUCT (reg, "log4cplus::", appendername, log4cplus::,         \
+            log4cplus::spi::AppenderFactory) 
+
+        #define DCMTK_LOG4CPLUS_REG_LAYOUT(reg, layoutname)                                 \
+        DCMTK_LOG4CPLUS_REG_PRODUCT (reg, "log4cplus::", layoutname, log4cplus::,           \
+            log4cplus::spi::LayoutFactory)
+
+        #define DCMTK_LOG4CPLUS_REG_FILTER(reg, filtername)                                 \
+        DCMTK_LOG4CPLUS_REG_PRODUCT (reg, "log4cplus::spi::", filtername, log4cplus::spi::, \
+            log4cplus::spi::FilterFactory)
+
+        #define DCMTK_LOG4CPLUS_REG_LOCALE(reg, name, factory)            \
+            reg.put (OFauto_ptr<log4cplus::spi::LocaleFactory> ( \
+                    new factory (name)))
+    } // namespace spi
 }
 } // end namespace dcmtk
 
 
 #endif // DCMTK_LOG4CPLUS_SPI_FACTORY_HEADER_
-
diff --git a/oflog/include/dcmtk/oflog/spi/filter.h b/oflog/include/dcmtk/oflog/spi/filter.h
index 7e85ea8..4a9405e 100644
--- a/oflog/include/dcmtk/oflog/spi/filter.h
+++ b/oflog/include/dcmtk/oflog/spi/filter.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    filter.h
 // Created: 5/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 1999-2009 Tad E. Smith
+// Copyright 1999-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,37 +19,50 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-/** @file
+/** @file 
  * This header defines Filter and all of it's subclasses. */
 
 #ifndef DCMTK_LOG4CPLUS_SPI_FILTER_HEADER_
 #define DCMTK_LOG4CPLUS_SPI_FILTER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/helpers/pointer.h"
-#include "dcmtk/oflog/helpers/property.h"
-#include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/loglevel.h"
 
 
 namespace dcmtk {
 namespace log4cplus {
+
+    namespace helpers
+    {
+
+        class Properties;
+
+    }
+
     namespace spi {
 
 
-        enum FilterResult { DENY, /**< The log event must be dropped immediately
-                                   *  without consulting with the remaining
+        enum FilterResult { DENY, /**< The log event must be dropped immediately 
+                                   *  without consulting with the remaining 
                                    *  filters, if any, in the chain. */
                             NEUTRAL, /**< This filter is neutral with respect to
-                                      *  the log event; the remaining filters, if
-                                      *  if any, should be consulted for a final
+                                      *  the log event; the remaining filters, if 
+                                      *  if any, should be consulted for a final 
                                       *  decision. */
-                            ACCEPT /**< The log event must be logged immediately
-                                    *  without consulting with the remaining
+                            ACCEPT /**< The log event must be logged immediately 
+                                    *  without consulting with the remaining 
                                     *  filters, if any, in the chain. */
                           };
 
         // Forward Declarations
         class Filter;
+        class InternalLoggingEvent;
 
 
         /**
@@ -56,7 +70,7 @@ namespace log4cplus {
          *
          * Note: <code>filter</code> can be NULL.
          */
-        DCMTK_LOG4CPLUS_EXPORT FilterResult checkFilter(const Filter* filter,
+        DCMTK_LOG4CPLUS_EXPORT FilterResult checkFilter(const Filter* filter, 
                                                   const InternalLoggingEvent& event);
 
         typedef helpers::SharedObjectPtr<Filter> FilterPtr;
@@ -65,7 +79,7 @@ namespace log4cplus {
         /**
          * Users should extend this class to implement customized logging
          * event filtering. Note that the {@link Logger} and {@link
-         * Appender} classes have built-in filtering rules. It is suggested
+         * Appender} classes have built-in filtering rules. It is suggested 
          * that you first use and understand the built-in rules before rushing
          * to write your own custom filters.
          *
@@ -76,7 +90,7 @@ namespace log4cplus {
          *
          * If the value {@link #DENY} is returned, then the log event is
          * dropped immediately without consulting with the remaining
-         * filters.
+         * filters. 
          *
          * If the value {@link #NEUTRAL} is returned, then the next filter
          * in the chain is consulted. If there are no more filters in the
@@ -84,13 +98,13 @@ namespace log4cplus {
          * filters, the default behaviour is to log all logging events.
          *
          * If the value {@link #ACCEPT} is returned, then the log
-         * event is logged without consulting the remaining filters.
+         * event is logged without consulting the remaining filters. 
          *
          * The philosophy of log4cplus filters is largely inspired from the
-         * Linux ipchains.
+         * Linux ipchains. 
          */
-        class DCMTK_LOG4CPLUS_EXPORT Filter
-            : public virtual helpers::SharedObject
+        class DCMTK_LOG4CPLUS_EXPORT Filter 
+            : public virtual log4cplus::helpers::SharedObject 
         {
         public:
           // ctor and dtor
@@ -103,7 +117,7 @@ namespace log4cplus {
              */
             void appendFilter(FilterPtr filter);
 
-            /**
+            /**     
              * If the decision is <code>DENY</code>, then the event will be
              * dropped. If the decision is <code>NEUTRAL</code>, then the next
              * filter, if any, will be invoked. If the decision is ACCEPT then
@@ -111,7 +125,7 @@ namespace log4cplus {
              * the chain.
              *
              * @param event The LoggingEvent to decide upon.
-             * @return The decision of the filter.
+             * @return The decision of the filter.  
              */
             virtual FilterResult decide(const InternalLoggingEvent& event) const = 0;
 
@@ -121,7 +135,7 @@ namespace log4cplus {
              */
             FilterPtr next;
         };
-
+  
 
 
         /**
@@ -135,10 +149,10 @@ namespace log4cplus {
         class DCMTK_LOG4CPLUS_EXPORT DenyAllFilter : public Filter {
         public:
             DenyAllFilter ();
-            DenyAllFilter (const helpers::Properties&, tstring& error);
+            DenyAllFilter (const log4cplus::helpers::Properties&);
 
             /**
-             * Always returns the {@link #DENY} regardless of the
+             * Always returns the {@link #DENY} regardless of the 
              * {@link InternalLoggingEvent} parameter.
              */
             virtual FilterResult decide(const InternalLoggingEvent& event) const;
@@ -151,7 +165,7 @@ namespace log4cplus {
          * The filter admits two options <b>LogLevelToMatch</b> and
          * <b>AcceptOnMatch</b>. If there is an exact match between the value
          * of the LogLevelToMatch option and the LogLevel of the {@link
-         * spi::InternalLoggingEvent}, then the {@link #decide} method returns
+         * spi::InternalLoggingEvent}, then the {@link #decide} method returns 
          * {@link #ACCEPT} in case the <b>AcceptOnMatch</b> option value is set
          * to <code>true</code>, if it is <code>false</code> then {@link #DENY}
          * is returned. If there is no match, {@link #NEUTRAL} is returned.
@@ -159,7 +173,7 @@ namespace log4cplus {
         class DCMTK_LOG4CPLUS_EXPORT LogLevelMatchFilter : public Filter {
         public:
             LogLevelMatchFilter();
-            LogLevelMatchFilter(const helpers::Properties& p, tstring&);
+            LogLevelMatchFilter(const log4cplus::helpers::Properties& p);
 
             /**
              * Return the decision of this filter.
@@ -167,7 +181,7 @@ namespace log4cplus {
              * Returns {@link #NEUTRAL} if the <b>LogLevelToMatch</b>
              * option is not set or if there is no match.  Otherwise, if
              * there is a match, then the returned decision is {@link #ACCEPT}
-             * if the <b>AcceptOnMatch</b> property is set to <code>true</code>.
+             * if the <b>AcceptOnMatch</b> property is set to <code>true</code>. 
              * The returned decision is {@link #DENY} if the <b>AcceptOnMatch</b>
              * property is set to <code>false</code>.
              */
@@ -175,7 +189,7 @@ namespace log4cplus {
 
         private:
           // Methods
-            void init();
+            DCMTK_LOG4CPLUS_PRIVATE void init();
 
           // Data
             /** Do we return ACCEPT when a match occurs. Default is <code>true</code>. */
@@ -214,7 +228,7 @@ namespace log4cplus {
         public:
           // ctors
             LogLevelRangeFilter();
-            LogLevelRangeFilter(const helpers::Properties& p, tstring& error);
+            LogLevelRangeFilter(const log4cplus::helpers::Properties& p);
 
             /**
              * Return the decision of this filter.
@@ -223,7 +237,7 @@ namespace log4cplus {
 
         private:
           // Methods
-            void init();
+            DCMTK_LOG4CPLUS_PRIVATE void init();
 
           // Data
             /** Do we return ACCEPT when a match occurs. Default is <code>true</code>. */
@@ -242,14 +256,14 @@ namespace log4cplus {
          * StringToMatch option and the message of the Logging event,
          * then the {@link #decide} method returns {@link #ACCEPT} if
          * the <b>AcceptOnMatch</b> option value is true, if it is false then
-         * {@link #DENY} is returned. If there is no match, {@link #NEUTRAL}
+         * {@link #DENY} is returned. If there is no match, {@link #NEUTRAL} 
          * is returned.
          */
         class DCMTK_LOG4CPLUS_EXPORT StringMatchFilter : public Filter {
         public:
           // ctors
             StringMatchFilter();
-            StringMatchFilter(const helpers::Properties& p, tstring& error);
+            StringMatchFilter(const log4cplus::helpers::Properties& p);
 
             /**
              * Returns {@link #NEUTRAL} is there is no string match.
@@ -258,12 +272,12 @@ namespace log4cplus {
 
         private:
           // Methods
-            void init();
+            DCMTK_LOG4CPLUS_PRIVATE void init();
 
           // Data
             /** Do we return ACCEPT when a match occurs. Default is <code>true</code>. */
             bool acceptOnMatch;
-            tstring stringToMatch;
+            log4cplus::tstring stringToMatch;
         };
 
     } // end namespace spi
diff --git a/oflog/include/dcmtk/oflog/spi/logevent.h b/oflog/include/dcmtk/oflog/spi/logevent.h
index 775e474..6fda9a5 100644
--- a/oflog/include/dcmtk/oflog/spi/logevent.h
+++ b/oflog/include/dcmtk/oflog/spi/logevent.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    loggingevent.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,17 +21,23 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_SPI_INTERNAL_LOGGING_EVENT_HEADER_
-#define DCMTK__LOG4CPLUS_SPI_INTERNAL_LOGGING_EVENT_HEADER_
+#ifndef DCMTK_LOG4CPLUS_SPI_INTERNAL_LOGGING_EVENT_HEADER_
+#define DCMTK_LOG4CPLUS_SPI_INTERNAL_LOGGING_EVENT_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include <memory>
+#include "dcmtk/ofstd/ofaptr.h"
 #include "dcmtk/oflog/loglevel.h"
 #include "dcmtk/oflog/ndc.h"
+#include "dcmtk/oflog/mdc.h"
 #include "dcmtk/oflog/tstring.h"
 #include "dcmtk/oflog/helpers/timehelp.h"
-#include "dcmtk/oflog/helpers/threads.h"
-
-#include "dcmtk/ofstd/ofaptr.h"
+#include "dcmtk/oflog/thread/threads.h"
 
 namespace dcmtk {
 namespace log4cplus {
@@ -50,82 +57,43 @@ namespace log4cplus {
               * Instantiate a LoggingEvent from the supplied parameters.
               *
               * @param logger   The logger of this event.
-              * @param ll_      The LogLevel of this event.
-              * @param message_ The message of this event.
+              * @param loglevel The LogLevel of this event.
+              * @param message  The message of this event.
               * @param filename Name of file where this event has occurred,
               * can be NULL.
-              * @param line_    Line number in file specified by
+              * @param line     Line number in file specified by
               *                 the <code>filename</code> parameter.
-              * @param function_ Function where this event has occurred
               */
-             InternalLoggingEvent(const tstring& logger,
-                                  LogLevel ll_,
-                                  const tstring& message_,
-                                  const char* filename,
-                                  int line_,
-                                  const char* function_)
-              : message(message_),
-                loggerName(logger),
-                ll(ll_),
-                ndc(),
-                thread(),
-                timestamp(helpers::Time::gettimeofday()),
-                file( (  filename
-                       ? DCMTK_LOG4CPLUS_C_STR_TO_TSTRING(filename)
-                       : tstring()) ),
-                line(line_),
-                function( ( function_
-                          ? DCMTK_LOG4CPLUS_C_STR_TO_TSTRING(function_)
-                          : tstring()) ),
-                threadCached(false),
-                ndcCached(false)
-             {
-             }
-
-             InternalLoggingEvent(const tstring& logger,
-                                  LogLevel ll_,
-                                  const tstring& ndc_,
-                                  const tstring& message_,
-                                  const tstring& thread_,
-                                  helpers::Time time,
-                                  const tstring& file_,
-                                  int line_,
-                                  const tstring& function_)
-              : message(message_),
-                loggerName(logger),
-                ll(ll_),
-                ndc(ndc_),
-                thread(thread_),
-                timestamp(time),
-                file(file_),
-                line(line_),
-                function(function_),
-                threadCached(true),
-                ndcCached(true)
-             {
-             }
-
-             InternalLoggingEvent(const spi::InternalLoggingEvent& rhs)
-              : message(rhs.getMessage()),
-                loggerName(rhs.getLoggerName()),
-                ll(rhs.getLogLevel()),
-                ndc(rhs.getNDC()),
-                thread(rhs.getThread()),
-                timestamp(rhs.getTimestamp()),
-                file(rhs.getFile()),
-                line(rhs.getLine()),
-                function(rhs.getFunction()),
-                threadCached(true),
-                ndcCached(true)
-             {
-             }
+            InternalLoggingEvent(const log4cplus::tstring& logger,
+                LogLevel loglevel, const log4cplus::tstring& message,
+                const char* filename, int line);
+
+            InternalLoggingEvent(const log4cplus::tstring& logger,
+                LogLevel loglevel, const log4cplus::tstring& ndc,
+                MappedDiagnosticContextMap const & mdc,
+                const log4cplus::tstring& message,
+                const log4cplus::tstring& thread,
+                log4cplus::helpers::Time time, const log4cplus::tstring& file,
+                int line);
+
+            InternalLoggingEvent ();
+
+            InternalLoggingEvent(
+                const log4cplus::spi::InternalLoggingEvent& rhs);
 
             virtual ~InternalLoggingEvent();
 
+            void setLoggingEvent (const log4cplus::tstring & logger,
+                LogLevel ll, const log4cplus::tstring & message,
+                const char * filename, int line);
+
+            void setFunction (char const * func);
+            void setFunction (log4cplus::tstring const &);
+
 
           // public virtual methods
             /** The application supplied message of logging event. */
-            virtual const tstring& getMessage() const;
+            virtual const log4cplus::tstring& getMessage() const;
 
             /** Returns the 'type' of InternalLoggingEvent.  Derived classes
              *  should override this method.  (NOTE: Values <= 1000 are
@@ -135,7 +103,7 @@ namespace log4cplus {
 
            /** Returns a copy of this object.  Derived classes
              *  should override this method.
-	     */
+             */
             virtual OFauto_ptr<InternalLoggingEvent> clone() const;
 
 
@@ -143,71 +111,121 @@ namespace log4cplus {
           // public methods
             /** The logger of the logging event. It is set by
              *  the LoggingEvent constructor.
-	     */
-            const tstring& getLoggerName() const { return loggerName; }
+             */
+            const log4cplus::tstring& getLoggerName() const
+            {
+                return loggerName;
+            }
 
             /** LogLevel of logging event. */
-            LogLevel getLogLevel() const { return ll; }
+            LogLevel getLogLevel() const
+            {
+                return ll;
+            }
 
             /** The nested diagnostic context (NDC) of logging event. */
-            const tstring& getNDC() const {
-                if(!ndcCached) {
-                    ndc = dcmtk::log4cplus::getNDC().get();
+            const log4cplus::tstring& getNDC() const
+            {
+                if (!ndcCached)
+                {
+                    ndc = log4cplus::getNDC().get();
                     ndcCached = true;
                 }
                 return ndc;
             }
 
+            MappedDiagnosticContextMap const & getMDCCopy () const
+            {
+                if (!mdcCached)
+                {
+                    mdc = log4cplus::getMDC().getContext ();
+                    mdcCached = true;
+                }
+                return mdc;
+            }
+
+            tstring const & getMDC (tstring const & key) const;
+
             /** The name of thread in which this logging event was generated. */
-            const tstring& getThread() const {
-                if(!threadCached) {
-                    thread = DCMTK_LOG4CPLUS_GET_CURRENT_THREAD_NAME;
+            const log4cplus::tstring& getThread() const
+            {
+                if (! threadCached)
+                {
+                    thread = thread::getCurrentThreadName ();
                     threadCached = true;
                 }
                 return thread;
             }
 
-            /** The number of milliseconds elapsed from 1/1/1970 until logging event
-             *  was created. */
-            const helpers::Time& getTimestamp() const { return timestamp; }
+            //! The alternative name of thread in which this logging event
+            //! was generated.
+            const log4cplus::tstring& getThread2() const
+            {
+                if (! thread2Cached)
+                {
+                    thread2 = thread::getCurrentThreadName2 ();
+                    thread2Cached = true;
+                }
+                return thread2;
+            }
+
+
+            /** The number of milliseconds elapsed from 1/1/1970 until
+             *  logging event was created. */
+            const log4cplus::helpers::Time& getTimestamp() const
+            {
+                return timestamp;
+            }
 
             /** The is the file where this log statement was written */
-            const tstring& getFile() const { return file; }
+            const log4cplus::tstring& getFile() const
+            {
+                return file;
+            }
 
             /** The is the line where this log statement was written */
             int getLine() const { return line; }
 
-            /** The is the function where this log statement was written */
-            const tstring& getFunction() const { return function; }
+            log4cplus::tstring const & getFunction () const
+            {
+                return function;
+            }
+
+            void gatherThreadSpecificData () const;
+
+            void swap (InternalLoggingEvent &);
 
           // public operators
-            spi::InternalLoggingEvent&
-            operator=(const spi::InternalLoggingEvent& rhs);
+            log4cplus::spi::InternalLoggingEvent&
+            operator=(const log4cplus::spi::InternalLoggingEvent& rhs);
 
           // static methods
             static unsigned int getDefaultType();
 
         protected:
           // Data
-            tstring message;
-
-        private:
-            tstring loggerName;
+            log4cplus::tstring message;
+            log4cplus::tstring loggerName;
             LogLevel ll;
-            mutable tstring ndc;
-            mutable tstring thread;
-            helpers::Time timestamp;
-            tstring file;
+            mutable log4cplus::tstring ndc;
+            mutable MappedDiagnosticContextMap mdc;
+            mutable log4cplus::tstring thread;
+            mutable log4cplus::tstring thread2;
+            log4cplus::helpers::Time timestamp;
+            log4cplus::tstring file;
+            log4cplus::tstring function;
             int line;
-            tstring function;
             /** Indicates whether or not the Threadname has been retrieved. */
             mutable bool threadCached;
+            mutable bool thread2Cached;
             /** Indicates whether or not the NDC has been retrieved. */
             mutable bool ndcCached;
+            /** Indicates whether or not the MDC has been retrieved. */
+            mutable bool mdcCached;
         };
 
     } // end namespace spi
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_SPI_INTERNAL_LOGGING_EVENT_HEADER_
+#endif // DCMTK_LOG4CPLUS_SPI_INTERNAL_LOGGING_EVENT_HEADER_
diff --git a/oflog/include/dcmtk/oflog/spi/logfact.h b/oflog/include/dcmtk/oflog/spi/logfact.h
index 9b93d3d..c3754d5 100644
--- a/oflog/include/dcmtk/oflog/spi/logfact.h
+++ b/oflog/include/dcmtk/oflog/spi/logfact.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    loggerfactory.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,12 +21,16 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_SPI_LOGGER_FACTORY_HEADER
-#define DCMTK__LOG4CPLUS_SPI_LOGGER_FACTORY_HEADER
+#ifndef DCMTK_LOG4CPLUS_SPI_LOGGER_FACTORY_HEADER
+#define DCMTK_LOG4CPLUS_SPI_LOGGER_FACTORY_HEADER
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/helpers/pointer.h"
 
 
 namespace dcmtk {
@@ -44,8 +49,8 @@ namespace log4cplus {
             /**
              * Creates a new <code>Logger</code> object.
              */
-            virtual Logger makeNewLoggerInstance(const tstring& name,
-                                                 Hierarchy& h) = 0;
+            virtual Logger makeNewLoggerInstance(const log4cplus::tstring& name,
+                                                 Hierarchy& h) = 0; 
             virtual ~LoggerFactory() = 0;
         };
 
@@ -53,5 +58,5 @@ namespace log4cplus {
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_SPI_LOGGER_FACTORY_HEADER
+#endif // DCMTK_LOG4CPLUS_SPI_LOGGER_FACTORY_HEADER
 
